#include <iostream>

using namespace std;

int main()
{
   int n;
   cin>>n;
   int r[n];
   int c[n];
   for(int i=0;i<n;i++)
   {
       cin>>r[i];
       cin>>c[i];
   }
   if(n==2)
   {if(r[0]!=r[1]&&c[0]!=c[1])
    cout<<0;
   else
    cout<<1;}
    else
        cout<<2;
}